unit main;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	StdCtrls, ComCtrls;

type
	TForm1 = class(TForm)
		OpenDialog: TOpenDialog;
    OpenBtn: TButton;
    TabToSpcBtn: TButton;
    ProgressBar: TProgressBar;
		procedure OpenBtnClick(Sender: TObject);
    procedure TabToSpcBtnClick(Sender: TObject);
	private
		{ Private declarations }
	public
		{ Public declarations }
	end;

var
	Form1: TForm1;

implementation

{$R *.DFM}

var
	fi,fo: file;
	fdt: TDateTime;

function GetFileDateTime(FileName: string): TDateTime;
var
	hFile: integer;
begin
	try
		hFile := FileOpen(FileName,fmOpenRead);
		Result := FileDateToDateTime(FileGetDate(hFile));
		FileClose(hFile);
	except
		Result := 0;
	end;
end;

function SetFileDateTime(FileName: string; DateTime: TDateTime): boolean;
var
	hFile: integer;
begin
	Result := TRUE;
	try
		hFile := FileOpen(FileName,fmOpenWrite);
		FileSetDate(hFile,DateTimeToFileDate(DateTime));
		FileClose(hFile);
	except
		Result := FALSE;
	end;
end;

procedure TForm1.OpenBtnClick(Sender: TObject);
var
	finame: string;
begin
	with OpenDialog do begin
		TabToSpcBtn.Enabled := Execute;
		if TabToSpcBtn.Enabled then begin
			finame := ChangeFileExt(FileName,'.bak');
			CopyFile(PChar(FileName),PChar(finame),FALSE);
			AssignFile(fi,finame);
			AssignFile(fo,FileName);
			fdt := GetFileDateTime(finame);
		end;
	end;
end;

procedure TForm1.TabToSpcBtnClick(Sender: TObject);
var
	c: char;
	Count: integer;
begin
	Reset(fi,1);
	ProgressBar.Max := FileSize(fi);
	ProgressBar.Position := 0;
	Rewrite(fo,1);
	while not EOF(fi) do begin
		Count := 1;
		BlockRead(fi,c,Count);
		if c <> #9 then BlockWrite(fo,c,1)
		else begin
			c := ' ';
			BlockWrite(fo,c,1);
			BlockWrite(fo,c,1);
		end;
		with ProgressBar do Position := Position + 1;
	end;
	CloseFile(fi);
	CloseFile(fo);
	SetFileDateTime(OpenDialog.FileName,fdt);
	TabToSpcBtn.Enabled := FALSE;
end;

end.
